Index: src/boundary.hpp
===================================================================
--- src/boundary.hpp	(revision 8a3e457fdc8672973ca81864d2f77e092e907b83)
+++ src/boundary.hpp	(revision 8a3e457fdc8672973ca81864d2f77e092e907b83)
@@ -0,0 +1,129 @@
+#ifndef BOUNDARY_HPP_
+#define BOUNDARY_HPP_
+
+class BoundaryPointSet;
+class BoundaryLineSet;
+class BoundaryTriangleSet;
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+// STL headers
+#include <map>
+#include <set>
+#include <deque>
+
+#include <gsl/gsl_poly.h>
+
+#include "molecules.hpp"
+
+#define DistanceNrPair pair < double, atom* >
+#define DistanceMap multimap < double, atom* >
+#define DistanceTestPair pair < DistanceMap::iterator, bool>
+
+#define Boundaries map <double, DistanceNrPair >
+#define BoundariesPair pair<double, DistanceNrPair >
+#define BoundariesTestPair pair< Boundaries::iterator, bool>
+
+#define PointMap map < int, class BoundaryPointSet * > 
+#define PointPair pair < int, class BoundaryPointSet * > 
+#define PointTestPair pair < PointMap::iterator, bool > 
+
+#define LineMap map < int, class BoundaryLineSet * > 
+#define LinePair pair < int, class BoundaryLineSet * > 
+#define LineTestPair pair < LinePair::iterator, bool > 
+
+#define TriangleMap map < int, class BoundaryTriangleSet * > 
+#define TrianglePair pair < int, class BoundaryTriangleSet * > 
+#define TriangleTestPair pair < TrianglePair::iterator, bool > 
+
+#define DistanceMultiMap multimap <double, pair < PointMap::iterator, PointMap::iterator> >
+#define DistanceMultiMapPair pair <double, pair < PointMap::iterator, PointMap::iterator> >
+
+template <typename T> void SetEndpointsOrdered(T endpoints[2], T endpoint1, T endpoint2)
+{
+  if (endpoint1->Nr < endpoint2->Nr) {
+    endpoints[0] = endpoint1;
+    endpoints[1] = endpoint2;
+  } else {
+    endpoints[0] = endpoint2;
+    endpoints[1] = endpoint1;
+  }
+};
+
+class BoundaryPointSet {
+  public:
+    BoundaryPointSet();
+    BoundaryPointSet(atom *Walker);
+    ~BoundaryPointSet();
+    
+    void AddLine(class BoundaryLineSet *line);
+    
+    LineMap lines;
+    int LinesCount;
+    atom *node;
+    int Nr;
+};
+
+class BoundaryLineSet {
+  public:
+    BoundaryLineSet();
+    BoundaryLineSet(class BoundaryPointSet *Point[2], int number);
+    ~BoundaryLineSet();
+
+    void AddTriangle(class BoundaryTriangleSet *triangle);
+
+    class BoundaryPointSet *endpoints[2];
+    TriangleMap triangles;
+    int TrianglesCount;
+    int Nr;
+};
+
+class BoundaryTriangleSet {
+  public:
+    BoundaryTriangleSet();
+    BoundaryTriangleSet(class BoundaryLineSet *line[3], int number);
+    ~BoundaryTriangleSet();
+    
+    void GetNormalVector(vector &NormalVector);
+    
+    class BoundaryPointSet *endpoints[3];
+    class BoundaryLineSet *lines[3];
+    int Nr;
+};
+
+class Tesselation {
+  public:
+    
+    Tesselation();
+    ~Tesselation();
+    
+    void TesselateOnBoundary(ofstream *out, config *configuration, molecule *mol);
+    void GuessStartingTriangle(ofstream *out);
+    void AddPoint(atom * Walker);
+    
+    PointMap PointsOnBoundary;
+    LineMap LinesOnBoundary;
+    TriangleMap TrianglesOnBoundary;
+    class BoundaryPointSet *BPS[2];
+    class BoundaryLineSet *BLS[3];
+    class BoundaryTriangleSet *BTS;
+    int PointsOnBoundaryCount;
+    int LinesOnBoundaryCount;
+    int TrianglesOnBoundaryCount;
+};
+
+
+ostream & operator << (ostream &ost, BoundaryPointSet &a);
+ostream & operator << (ostream &ost, BoundaryLineSet &a);
+ostream & operator << (ostream &ost, BoundaryTriangleSet &a);
+
+
+double VolumeOfConvexEnvelope(ofstream *out, config *configuration, Boundaries *BoundaryPoints, molecule *mol);
+double * GetDiametersOfCluster(ofstream *out, Boundaries *BoundaryPtr, molecule *mol, bool IsAngstroem);
+void PrepareClustersinWater(ofstream *out, config *configuration, molecule *mol, double ClusterVolume, double celldensity);
+
+
+#endif /*BOUNDARY_HPP_*/
Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision d250b29e2b8e1c054b7f93c4f475f36dfb7a3a33)
+++ src/builder.cpp	(revision 8a3e457fdc8672973ca81864d2f77e092e907b83)
@@ -52,4 +52,5 @@
 #include "helpers.hpp"
 #include "molecules.hpp"
+#include "boundary.hpp"
 
 /********************************************** Submenu routine **************************************/
@@ -484,5 +485,5 @@
  * \param *mol the molecule with all the atoms
  */
-static void MeasureAtoms(periodentafel *periode, molecule *mol)
+static void MeasureAtoms(periodentafel *periode, molecule *mol, config *configuration)
 {
   atom *first, *second, *third;
@@ -496,4 +497,6 @@
   cout << Verbose(0) << " b - calculate bond length between two atoms" << endl;
   cout << Verbose(0) << " c - calculate bond angle" << endl;
+  cout << Verbose(0) << " d - calculate principal axis of the system" << endl;
+  cout << Verbose(0) << " e - calculate volume of the convex envelope" << endl;
   cout << Verbose(0) << "all else - go back" << endl;
   cout << Verbose(0) << "===============================================" << endl;
@@ -553,4 +556,17 @@
       cout << Verbose(0) << (acos(x.ScalarProduct((const vector *)&y)/(y.Norm()*x.Norm()))/M_PI*180.) << " degrees" << endl;         
       break;
+    case 'd':
+    	cout << Verbose(0) << "Evaluating prinicipal axis." << endl;
+    	cout << Verbose(0) << "Shall we rotate? [0/1]: ";
+    	cin >> Z;
+    	if ((Z >=0) && (Z <=1))
+    	  mol->PrincipalAxisSystem((ofstream *)&cout, (bool)Z);
+    	else
+    	  mol->PrincipalAxisSystem((ofstream *)&cout, false);
+    	break;
+    case 'e':
+    	cout << Verbose(0) << "Evaluating volume of the convex envelope.";
+    	VolumeOfConvexEnvelope((ofstream *)&cout, configuration, NULL, mol);
+    	break;
   }
 };
@@ -720,4 +736,5 @@
   int ExitFlag = 0;
   int j;
+  double volume = 0.;
   enum ConfigStatus config_present = absent;
   clock_t start,end;
@@ -742,11 +759,16 @@
             cout << "\t-b x1 x2 x3\tCenter atoms in domain with given edge lengths of (x1,x2,x3)." << endl;
             cout << "\t-c x1 x2 x3\tCenter atoms in domain with a minimum distance to boundary of (x1,x2,x3)." << endl;
+            cout << "\t-d x1 x2 x3\tDuplicate cell along each axis by given factor." << endl;
             cout << "\t-e <file>\tSets the databases path to be parsed (default: ./)." << endl;
             cout << "\t-f <dist> <order>\tFragments the molecule in BOSSANOVA manner and stores config files in same dir as config." << endl;
             cout << "\t-h/-H/-?\tGive this help screen." << endl;
+            cout << "\t-m\tAlign in PAS with greatest EV along z axis." << endl;
+            cout << "\t-n\tFast parsing (i.e. no trajectories are looked for)." << endl;
+            cout << "\t-o\tGet volume of the convex envelope (and store to tecplot file)." << endl;
             cout << "\t-p <file>\tParse given xyz file and create raw config file from it." << endl;
             cout << "\t-r\t\tConvert file from an old pcp syntax." << endl;
             cout << "\t-t x1 x2 x3\tTranslate all atoms by this vector (x1,x2,x3)." << endl;
             cout << "\t-s x1 x2 x3\tScale all atom coordinates by this vector (x1,x2,x3)." << endl;
+            cout << "\t-u rho\tsuspend in water solution and output necessary cell lengths, average density rho and repetition." << endl; 
             cout << "\t-v/-V\t\tGives version information." << endl;
             cout << "Note: config files must not begin with '-' !" << endl;
@@ -768,4 +790,7 @@
             argptr+=1;
             break;
+          case 'n':
+            cout << "I won't parse trajectories." << endl;
+            configuration.FastParsing = true;
           default:   // no match? Step on
             argptr++;
@@ -780,6 +805,8 @@
       cout << Verbose(0) << "Element list loaded successfully." << endl;
       periode->Output((ofstream *)&cout);
-    } else
+    } else {
       cout << Verbose(0) << "Element list loading failed." << endl;
+      return 1;
+    }
     
     // 3. Find config file name and parse if possible
@@ -945,6 +972,99 @@
               }
               break;
+            case 'm':
+              ExitFlag = 1;
+              j = atoi(argv[argptr++]);
+              if ((j<0) || (j>1)) {
+                cerr << Verbose(1) << "ERROR: Argument of '-m' should be either 0 for no-rotate or 1 for rotate." << endl;
+                j = 0;
+              }
+              if (j)
+                cout << Verbose(0) << "Converting to prinicipal axis system." << endl;
+              else
+                cout << Verbose(0) << "Evaluating prinicipal axis." << endl;
+              mol->PrincipalAxisSystem((ofstream *)&cout, (bool)j);
+              break;
+            case 'o':
+              ExitFlag = 1;
+              cout << Verbose(0) << "Evaluating volume of the convex envelope.";
+              VolumeOfConvexEnvelope((ofstream *)&cout, &configuration, NULL, mol);
+              break;
+            case 'U':
+              volume = atof(argv[argptr++]);
+              cout << Verbose(0) << "Using " << volume << " angstrom^3 as the volume instead of convex envelope one's." << endl;  
+            case 'u':
+              {
+                double density;
+                ExitFlag = 1;
+                cout << Verbose(0) << "Evaluating necessary cell volume for a cluster suspended in water.";
+                density = atof(argv[argptr++]);
+                if (density < 1.0) {
+                  cerr << Verbose(0) << "Density must be greater than 1.0g/cm^3 !" << endl;
+                  density = 1.3;
+                }
+//                for(int i=0;i<NDIM;i++) {
+//                  repetition[i] = atoi(argv[argptr++]);
+//                  if (repetition[i] < 1)
+//                    cerr << Verbose(0) << "ERROR: repetition value must be greater 1!" << endl;
+//                  repetition[i] = 1;
+//                }
+                PrepareClustersinWater((ofstream *)&cout, &configuration, mol, volume, density);
+              }
+              break;
+            case 'd':
+              for (int axis = 1; axis <= NDIM; axis++) {
+                int faktor = atoi(argv[argptr++]);
+                int count;
+                element ** Elements;
+                vector ** Vectors;
+                if (faktor < 1) {
+                  cerr << Verbose(0) << "ERROR: Repetition faktor mus be greater than 1!" << endl;
+                  faktor = 1;
+                }
+                mol->CountAtoms((ofstream *)&cout);  // recount atoms
+                if (mol->AtomCount != 0) {  // if there is more than none
+                  count = mol->AtomCount;   // is changed becausing of adding, thus has to be stored away beforehand
+                  Elements = new element *[count];
+                  Vectors = new vector *[count];
+                  j = 0;
+                  first = mol->start;
+                  while (first->next != mol->end) {  // make a list of all atoms with coordinates and element
+                    first = first->next;
+                    Elements[j] = first->type;
+                    Vectors[j] = &first->x;
+                    j++;
+                  }
+                  if (count != j)
+                    cout << Verbose(0) << "ERROR: AtomCount " << count << " is not equal to number of atoms in molecule " << j << "!" << endl;
+                  x.Zero();
+                  y.Zero();
+                  y.x[abs(axis)-1] = mol->cell_size[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] * abs(axis)/axis; // last term is for sign, first is for magnitude
+                  for (int i=1;i<faktor;i++) {  // then add this list with respective translation factor times
+                    x.AddVector(&y); // per factor one cell width further
+                    for (int k=count;k--;) { // go through every atom of the original cell
+                      first = new atom(); // create a new body
+                      first->x.CopyVector(Vectors[k]);  // use coordinate of original atom
+                      first->x.AddVector(&x);      // translate the coordinates
+                      first->type = Elements[k];  // insert original element
+                      mol->AddAtom(first);        // and add to the molecule (which increments ElementsInMolecule, AtomCount, ...)
+                    }
+                  }
+                  // free memory
+                  delete[](Elements);
+                  delete[](Vectors);
+                  // correct cell size
+                  if (axis < 0) { // if sign was negative, we have to translate everything
+                    x.Zero();
+                    x.AddVector(&y);
+                    x.Scale(-(faktor-1));
+                    mol->Translate(&x);
+                  }
+                  mol->cell_size[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] *= faktor; 
+                }
+              }
+              break;
             default:   // no match? Step on
-              argptr++;
+              if (argv[argptr][0] != '-') // if it started with a '-' we've already made a step!
+                argptr++;
               break;
           }
@@ -1151,5 +1271,5 @@
 
       case 'l': // measure distances or angles
-        MeasureAtoms(periode, mol);
+        MeasureAtoms(periode, mol, &configuration);
         break;
 
@@ -1164,5 +1284,5 @@
         mol->CreateAdjacencyList((ofstream *)&cout, tmp1, configuration.GetIsAngstroem());
         //mol->CreateListOfBondsPerAtom((ofstream *)&cout);
-        Subgraphs = mol->DepthFirstSearchAnalysis((ofstream *)&cout, false, MinimumRingSize);
+        Subgraphs = mol->DepthFirstSearchAnalysis((ofstream *)&cout, MinimumRingSize);
         while (Subgraphs->next != NULL) {
           Subgraphs = Subgraphs->next;
@@ -1220,5 +1340,5 @@
   
   // save element data base
-  if (periode->StorePeriodentafel()) //ElementsFileName
+  if (periode->StorePeriodentafel(ElementsFileName)) //ElementsFileName
     cout << Verbose(0) << "Saving of elements.db successful." << endl;
   else
Index: src/config.cpp
===================================================================
--- src/config.cpp	(revision d250b29e2b8e1c054b7f93c4f475f36dfb7a3a33)
+++ src/config.cpp	(revision 8a3e457fdc8672973ca81864d2f77e092e907b83)
@@ -24,4 +24,5 @@
   configname[0]='\0';
   
+  FastParsing = false;
   ProcPEGamma=8;
   ProcPEPsi=1;
@@ -455,8 +456,8 @@
   string zeile;
   string dummy;
-  element *elementhash[128];
-  char name[128];
-  char keyword[128];
-  int Z, No;
+  element *elementhash[MAX_ELEMENTS];
+  char name[MAX_ELEMENTS];
+  char keyword[MAX_ELEMENTS];
+  int Z, No[MAX_ELEMENTS];
   int verbose = 0;
   
@@ -632,20 +633,28 @@
   if (!ParseForParameter(verbose,file,"StructOpt", 0, 1, 1, int_type, &(config::StructOpt), 1, optional))
     config::StructOpt = 0;
+  // prescan number of ions per type
+  cout << Verbose(0) << "Prescanning ions per type: " << endl;
   for (int i=0; i < config::MaxTypes; i++) {
     sprintf(name,"Ion_Type%i",i+1);
-    ParseForParameter(verbose,file, (const char*)name, 0, 1, 1, int_type, &No, 1, critical);
+    ParseForParameter(verbose,file, (const char*)name, 0, 1, 1, int_type, &No[i], 1, critical);
     ParseForParameter(verbose,file, name, 0, 2, 1, int_type, &Z, 1, critical);
     elementhash[i] = periode->FindElement(Z);
-    for(int j=0;j<No;j++) {
+    cout << Verbose(1) << i << ". Z = " << elementhash[i]->Z << " with " << No[i] << " ions." << endl; 
+  }
+  for (int i=0; i < config::MaxTypes; i++) {
+    sprintf(name,"Ion_Type%i",i+1);
+    for(int j=0;j<No[i];j++) {
       int repetition = 1; // which repeated keyword shall be read
       sprintf(keyword,"%s_%i",name, j+1);
       atom *neues = new atom();
       // then parse for each atom the coordinates as often as present
-      while (ParseForParameter(verbose,file, keyword, 0, 1, 1, double_type, &neues->x.x[0], repetition, (repetition == 1) ? critical : optional) &&
-        ParseForParameter(verbose,file, keyword, 0, 2, 1, double_type, &neues->x.x[1], repetition, (repetition == 1) ? critical : optional) &&
-        ParseForParameter(verbose,file, keyword, 0, 3, 1, double_type, &neues->x.x[2], repetition, (repetition == 1) ? critical : optional))
-        repetition++;
-      repetition--;
-      //cout << "Found " << repetition << " times of the keyword " << keyword << "." << endl;
+      if (!FastParsing) {
+        while (ParseForParameter(verbose,file, keyword, 0, 1, 1, double_type, &neues->x.x[0], repetition, (repetition == 1) ? critical : optional) &&
+          ParseForParameter(verbose,file, keyword, 0, 2, 1, double_type, &neues->x.x[1], repetition, (repetition == 1) ? critical : optional) &&
+          ParseForParameter(verbose,file, keyword, 0, 3, 1, double_type, &neues->x.x[2], repetition, (repetition == 1) ? critical : optional))
+          repetition++;
+        repetition--;
+        //cout << "Found " << repetition << " times of the keyword " << keyword << "." << endl;
+      }
       ParseForParameter(verbose,file, keyword, 0, 1, 1, double_type, &neues->x.x[0], repetition,critical);
       ParseForParameter(verbose,file, keyword, 0, 2, 1, double_type, &neues->x.x[1], repetition,critical);
@@ -656,5 +665,5 @@
       if(!ParseForParameter(verbose,file, keyword, 0, 6, 1, double_type, &neues->v.x[1], repetition,optional))
         neues->v.x[1] = 0.;
-      if(!ParseForParameter(verbose,file, keyword, 0, 7, 1, double_type, &neues->v.x[2], repetition,optional))
+      if(!ParseForParameter(verbose,file, keyword, (int)FastParsing, 7, 1, double_type, &neues->v.x[2], repetition,optional))
         neues->v.x[2] = 0.;
       neues->type = elementhash[i]; // find element type
Index: src/defs.hpp
===================================================================
--- src/defs.hpp	(revision d250b29e2b8e1c054b7f93c4f475f36dfb7a3a33)
+++ src/defs.hpp	(revision 8a3e457fdc8672973ca81864d2f77e092e907b83)
@@ -43,18 +43,24 @@
 
 // various standard filenames
-#define DEFAULTCONFIG "main_pcp_linux"
-#define KEYSETFILE "KeySets.dat"
-#define ADJACENCYFILE "Adjacency.dat"
-#define TEFACTORSFILE "TE-Factors.dat"
-#define FORCESFILE "Forces-Factors.dat"
-#define ORDERATSITEFILE "OrderAtSite.dat"
-#define ENERGYPERFRAGMENT "EnergyPerFragment"
-#define FRAGMENTPREFIX "BondFragment"
-#define STANDARDCONFIG "unknown.conf"
-#define STANDARDELEMENTSDB "elements.db"
-#define STANDARDVALENCEDB "valence.db"
-#define STANDARDORBITALDB "orbitals.db"
-#define STANDARDHBONDDISTANCEDB "Hbonddistance.db"
-#define STANDARDHBONDANGLEDB "Hbondangle.db"
+#define DEFAULTCONFIG "main_pcp_linux"    //!< default filename of config file
+#define CONVEXENVELOPE "ConvexEnvelope.dat"    //!< default filename of convex envelope tecplot data file
+#define KEYSETFILE "KeySets.dat"    //!< default filename of BOSSANOVA key sets file
+#define ADJACENCYFILE "Adjacency.dat"    //!< default filename of BOSSANOVA adjacancy file
+#define TEFACTORSFILE "TE-Factors.dat"    //!< default filename of BOSSANOVA total energy factors file
+#define FORCESFILE "Forces-Factors.dat"    //!< default filename of BOSSANOVA force factors file
+#define ORDERATSITEFILE "OrderAtSite.dat"    //!< default filename of BOSSANOVA Bond Order at each atom file
+#define ENERGYPERFRAGMENT "EnergyPerFragment"    //!< default filename of BOSSANOVA Energy contribution Per Fragment file
+#define FRAGMENTPREFIX "BondFragment"    //!< default filename prefix of BOSSANOVA fragment config and directories 
+#define STANDARDCONFIG "unknown.conf"    //!< default filename of standard config file
+#define STANDARDELEMENTSDB "elements.db"    //!< default filename of elements data base with masses, Z, VanDerWaals radii, ...
+#define STANDARDVALENCEDB "valence.db"    //!< default filename of valence number per element database
+#define STANDARDORBITALDB "orbitals.db"    //!< default filename of orbitals per element database
+#define STANDARDHBONDDISTANCEDB "Hbonddistance.db"    //!< default filename of typial bond distance to hydrogen database
+#define STANDARDHBONDANGLEDB "Hbondangle.db"    //!< default filename of typial bond angle to hydrogen database
+
+// some values
+#define SOLVENTDENSITY_A 0.6022142
+#define SOLVENTDENSITY_a0 0.089238936
+
 
 #define UPDATECOUNT 10  //!< update ten sites per BOSSANOVA interval
Index: src/moleculelist.cpp
===================================================================
--- src/moleculelist.cpp	(revision d250b29e2b8e1c054b7f93c4f475f36dfb7a3a33)
+++ src/moleculelist.cpp	(revision 8a3e457fdc8672973ca81864d2f77e092e907b83)
@@ -240,8 +240,8 @@
     *out << endl;
     // prepare output of config file
-    sprintf(FragmentName, "%s/%s%s.conf", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
+    sprintf(FragmentName, "%s/%s%s.conf", PathBackup, FRAGMENTPREFIX, FragmentNumber);
     outputFragment.open(FragmentName, ios::out);
-    strcpy(PathBackup, configuration->configpath);
-    sprintf(FragmentName, "%s/%s%s/", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
+    //strcpy(PathBackup, configuration->configpath);
+    sprintf(FragmentName, "%s/%s%s/", PathBackup, FRAGMENTPREFIX, FragmentNumber);
     
     // center on edge
@@ -251,5 +251,5 @@
     for (int k=0;k<NDIM;k++) {
       j += k+1;
-      BoxDimension.x[k] = 5.;
+      BoxDimension.x[k] = 2.5* (configuration->GetIsAngstroem() ? 1. : 1./AtomicLengthToAngstroem);
       ListOfMolecules[i]->cell_size[j] += BoxDimension.x[k]*2.;
     }
